models/Lineas.php
<?php

namespace app\models;

use Yii;
use yii\helpers\ArrayHelper;

/**
 * This is the model class for table "lineas".
 *
 * @property int $id
 * @property int|null $producto
 * @property string|null $nombreProducto
 * @property float|null $precio
 * @property int|null $cantidad
 * @property float|null $total
 * @property int|null $factura
 *
 * @property Factura $factura0
 * @property Productos $producto0
 */
class Lineas extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'lineas';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['producto', 'cantidad', 'factura'], 'integer'],
            [['precio', 'total'], 'number'],
            [['nombreProducto'], 'string', 'max' => 100],
            [['factura'], 'exist', 'skipOnError' => true, 'targetClass' => Factura::class, 'targetAttribute' => ['factura' => 'id']],
            [['producto'], 'exist', 'skipOnError' => true, 'targetClass' => Productos::class, 'targetAttribute' => ['producto' => 'id']],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'producto' => 'Producto',
            'nombreProducto' => 'Nombre Producto',
            'precio' => 'Precio',
            'cantidad' => 'Cantidad',
            'total' => 'Total',
            'factura' => 'Factura',
        ];
    }

    /**
     * Gets query for [[Factura0]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getFactura0()
    {
        return $this->hasOne(Factura::class, ['id' => 'factura']);
    }

    /**
     * Gets query for [[Producto0]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getProducto0()
    {
        return $this->hasOne(Productos::class, ['id' => 'producto']);
    }

    public function getProductos()
    {
        $secciones = Productos::find()->all();
        return ArrayHelper::map($secciones, 'id', 'nombre');
    }

    public function getFacturas()
    {
        $secciones = Factura::find()->all();
        return ArrayHelper::map($secciones, 'id', 'id');
    }
}

controllers/LineasController.php
<?php

namespace app\controllers;

use app\models\Lineas;
use Yii;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * LineasController implements the CRUD actions for Lineas model.
 */
class LineasController extends Controller
{
    /**
     * @inheritDoc
     */
    public function behaviors()
    {
        return array_merge(
            parent::behaviors(),
            [
                'verbs' => [
                    'class' => VerbFilter::className(),
                    'actions' => [
                        'delete' => ['POST'],
                    ],
                ],
            ]
        );
    }

    /**
     * Lists all Lineas models.
     *
     * @return string
     */
    public function actionIndex()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Lineas::find(),
            /*
            'pagination' => [
                'pageSize' => 50
            ],
            'sort' => [
                'defaultOrder' => [
                    'id' => SORT_DESC,
                ]
            ],
            */
        ]);

        return $this->render('index', [
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Lineas model.
     * @param int $id ID
     * @return string
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new Lineas model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return string|\yii\web\Response
     */
    public function actionCreate()
    {
        $model = new Lineas();

        if ($this->request->isPost) {
            if ($model->load($this->request->post()) && $model->save()) {
                return $this->redirect(['view', 'id' => $model->id]);
            }
        } else {
            $model->loadDefaultValues();
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing Lineas model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param int $id ID
     * @return string|\yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($this->request->isPost && $model->load($this->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Lineas model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param int $id ID
     * @return \yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Lineas model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param int $id ID
     * @return Lineas the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Lineas::findOne(['id' => $id])) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }

    public function actionActualizar()
    {
        Yii::$app->db->createCommand("call actualizarLineas()")->query();
        return $this->redirect(['index']);
    }
    public function actionActualizarlinea($id)
    {
        Yii::$app->db->createCommand("call actualizarLinea($id)")->query();
        return $this->redirect(['view', 'id' => $id]);
    }
}

views/lineas/_form.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/** @var yii\web\View $this */
/** @var app\models\Lineas $model */
/** @var yii\widgets\ActiveForm $form */
?>

<div class="lineas-form">

    <?php $form = ActiveForm::begin(); ?>

    <?= $form->field($model, 'producto')->dropDownList($model->productos) ?>

    <?= $form->field($model, 'nombreProducto')->textInput(['disabled' => true]) ?>

    <?= $form->field($model, 'precio')->textInput(['disabled' => true]) ?>

    <?= $form->field($model, 'cantidad')->input('number') ?>

    <?= $form->field($model, 'total')->textInput(['disabled' => true]) ?>

    <?= $form->field($model, 'factura')->dropDownList($model->facturas) ?>

    <div class="form-group">
        <?= Html::submitButton('Save', ['class' => 'btn btn-success']) ?>
    </div>

    <?php ActiveForm::end(); ?>

</div>

views/lineas/create.php
<?php

use yii\helpers\Html;

/** @var yii\web\View $this */
/** @var app\models\Lineas $model */

$this->title = 'Create Lineas';
$this->params['breadcrumbs'][] = ['label' => 'Lineas', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="lineas-create">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

views/lineas/index.php
<?php

use app\models\Lineas;
use yii\helpers\Html;
use yii\helpers\Url;
use yii\grid\ActionColumn;
use yii\grid\GridView;

/** @var yii\web\View $this */
/** @var yii\data\ActiveDataProvider $dataProvider */

$this->title = 'Lineas';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="lineas-index">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a('Nuevo', ['lineas/create'], ['class' => 'btn btn-success']) ?>
        <?= Html::a('Actualizar Datos', ['lineas/actualizar'], ['class' => 'btn btn-success']) ?>
    </p>


    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],

            'id',
            'producto',
            'nombreProducto',
            'precio',
            'cantidad',
            'total',
            'factura',
            [
                'format' => 'raw',
                'value' => function ($model) {
                    return Html::a('<i class="far fa-person-sign"></i>Actualizar Datos Linea', ['lineas/actualizarlinea', 'id' => $model->id], ['class' => 'btn btn-secondary']);
                }
            ],
            [
                'class' => ActionColumn::className(),
                'urlCreator' => function ($action, Lineas $model, $key, $index, $column) {
                    return Url::toRoute(["lineas/$action", 'id' => $model->id]);
                }
            ],
        ],
    ]); ?>


</div>

views/lineas/update.php
<?php

use yii\helpers\Html;

/** @var yii\web\View $this */
/** @var app\models\Lineas $model */

$this->title = 'Update Lineas: ' . $model->id;
$this->params['breadcrumbs'][] = ['label' => 'Lineas', 'url' => ['index']];
$this->params['breadcrumbs'][] = ['label' => $model->id, 'url' => ['view', 'id' => $model->id]];
$this->params['breadcrumbs'][] = 'Update';
?>
<div class="lineas-update">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

views/lineas/view.php
<?php

use yii\helpers\Html;
use yii\widgets\DetailView;

/** @var yii\web\View $this */
/** @var app\models\Lineas $model */

$this->title = $model->id;
$this->params['breadcrumbs'][] = ['label' => 'Lineas', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
\yii\web\YiiAsset::register($this);
?>
<div class="lineas-view">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a('Actualizar', ['update', 'id' => $model->id], ['class' => 'btn btn-primary']) ?>
        <?= Html::a('Eliminar', ['delete', 'id' => $model->id], [
            'class' => 'btn btn-danger',
            'data' => [
                'confirm' => 'Are you sure you want to delete this item?',
                'method' => 'post',
            ],
        ]) ?>
        <?= Html::a('<i class="far fa-person-sign"></i>Actualizar Datos Linea', ['lineas/actualizarlinea', 'id' => $model->id], ['class' => 'btn btn-secondary']) ?>
    </p>

    <?= DetailView::widget([
        'model' => $model,
        'attributes' => [
            'id',
            'producto',
            'nombreProducto',
            'precio',
            'cantidad',
            'total',
            'factura',
        ],
    ]) ?>

</div>